IS-IS Extensions for BIER-TE
Huaimo Chen
Futurewei
Boston, MA
USA
hchen.ietf@gmail.com
Mike McBride
Futurewei
michael.mcbride@futurewei.com
Aijun Wang
China Telecom
Beiqijia Town, Changping District
Beijing
102209
China
wangaj3@chinatelecom.cn
Gyan S. Mishra
Verizon Inc.
13101 Columbia Pike
Silver Spring
MD 20904
USA
301 502-1347
gyan.s.mishra@verizon.com
Yanhe Fan
Casa Systems
USA
yfan@casa-systems.com
Lei Liu
Fujitsu
USA
liulei.kddi@gmail.com
Xufeng Liu
Alef Edge
USA
xufeng.liu.ietf@gmail.com
2024
This document describes IS-IS extensions for distributing the BitPositions configured on a Bit-Forwarding Router (BFR) in a "Bit Index Explicit Replication Traffic Engineering" (BIER-TE) domain.

Requirements Language
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in [RFC2119] [RFC8174] when, and only when, they appear in all capitals, as shown here.

Introduction
[RFC9262] introduces Bit Index Explicit Replication (BIER) Traffic/Tree Engineering (BIER-TE). It is an architecture for per-packet stateless explicit point to multipoint (P2MP) multicast path/tree.
There are three types of BitPositions (BPs) in a BIER-TE domain: link BitPosition (BP), routed BP and localdecap BP.
A link BP is a BP configured on a link from Bit-Forwarding Router (BFR) X to BFR Y for a forward connected adjacency from X to Y.
A routed BP is a BP configured on BFR X for a forward routed adjacency from X to a remote BFR Z not directly connected to X.
A localdecap BP is a BP configured on a BFR.
[RFC8401] describes IS-IS Extensions for distributing the BFR identifier (BFR-id) configured on a BFR.
This document specifies IS-IS extensions for distributing the BitPositions configured a BFR in a BIER-TE domain. The BitPositions distributed may be used by a BFR as a Point of Local Repair (PLR) for Fast-ReRoute (FRR).

Extensions to IS-IS
This section describes protocol extensions to IS-IS for distributing the BitPositions configured on a BFR in a BIER-TE domain.

Link BitPosition
An Extended IS Reachability TLV (Type 22) defined in [RFC5305] may contain Sub-TLVs (such as those for TE) that apply to a link/interface to a neighbor.
To encode multiple links or interfaces to neighbors, the structure inside TLV is repeated.
MT Intermediate Systems TLV (Type 222) defined in [RFC5120] may contain Sub-TLVs (such as those for TE) that apply to a link/interface. It is aligned with Extended IS Reachability TLV (Type 22) beside an additional two bytes in front at the beginning of the TLV for MT-ID.
Link-BP Sub-TLV of the following format is defined and used in Extended IS Reachability TLV (Type 22) and/or MT Intermediate Systems TLV (Type 222) to advertise a link BP.

Link-BP Sub-TLV
    0                   1                   2                   3
    0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
   |  Type (TBD1)  |    Length     |
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
   |      BAR      |    IPA        | sub-domain-id |
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
   |         BitPosition           |       DisEndBitPosition       |
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
   ~                        Sub-Sub-TLVs (variable)                ~
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
Type: TBD1 is to be assigned by IANA.
Length: Variable, dependent on Sub-Sub-TLVs.
BAR, IPA and sub-domain-id: They are defined in Section 6.1 of [RFC8401].
BitPosition: A 2-octet field encoding the BitPosition locally configured on the link/interface to an Intermediate System neighbor.
DisEndBitPosition: A 2-octet field encoding the BitPosition of the connection on the designated Intermediate Systems (Dis) end. This field exists when the neighbor is a pseudonode. If the neighbor is not a pseudonode, this field MUST NOT exist. The DisEndBitPosition may be configured on the link/interface to a transit network (i.e., broadcast link or say LAN) as described in [I-D.chen-bier-te-lan].
No Sub-Sub-TLVs are currently defined.

Routed and Localdecap BitPositions
A Sub-TLV, called Node BPs Sub-TLV, is defined and carried within the TLVs 235, 237 [RFC5120], 135 [RFC5305], or 236 [RFC5308].
It contains Sub-Sub-TLVs. Two types of Sub-Sub-TLVs are defined. One is for a Routed BitPosition and the other for a Localdecap BitPosition.
The Node BPs Sub-TLV has the following format:

Node BPs Sub-TLV
    0                   1                   2                   3
    0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
   | Type (TBD2)   |    Length     |
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
   |      BAR      |    IPA        | sub-domain-id |
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
   |                        Sub-Sub-TLVs                           ~
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
Type: TBD2 is to be assigned by IANA.
Length: Variable.
BAR, IPA and sub-domain-id: They are defined in Section 6.1 of [RFC8401].
Sub-Sub-TLVs: They are Routed-BP Sub-Sub-TLVs for Routed BPs and/or Localdecap-BP Sub-Sub-TLV for Localdecap BP.
The Routed-BP Sub-Sub-TLV has the following format:

Routed-BP Sub-Sub-TLV
    0                   1                   2                   3
    0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
   |   Type (1)    |    Length(4)  |
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
   |         BitPosition           |             BFR-id            |
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
Type: 1 is the type for routed BP.
Length: It is 4.
BitPosition: A 2-octet field encoding the BitPosition configured on a BFR for a forward routed adjacency to a remote BFR.
BFR-id: A 2-octet field encoding the BFR-id of the remote BFR.
The Localdecap-BP Sub-Sub-TLV has the following format:

Localdecap-BP Sub-Sub-TLV
    0                   1                   2                   3
    0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
   |   Type (2)    |   Length(2)   |
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
   |         BitPosition           |
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
Type: 2 is the type for localdecap BP.
Length: It is 2.
BitPosition: A 2-octet field encoding the localdecap BitPosition configured on a BFR.

Security Considerations
Protocol extensions defined in this document do not affect the IS-IS security.

IANA Considerations
Under "IS-IS Sub-TLVs for TLVs Advertising Neighbor Information" registry, IANA is requested to assign a new Sub-TLV Type for Link BP as follows:
  +=======+=============+==+==+==+===+===+===+=============+
  | Type  |Description  |22|23|25|141|222|223|reference    |
  +=======+=============+==+==+==+===+===+===+=============+
  | TBD1  |  Link BP    |y |y |n | n | y | y |This document|
  +-------+-------------+--+--+--+---+---+---+-------------+

Under "IS-IS Sub-TLVs for TLVs Advertising Prefix Reachability" registry, IANA is requested to assign a new Sub-TLV Type for Node BPs as follows:
  +=======+=============+==+===+===+===+===+=============+
  | Type  |Description  |27|135|235|236|237|reference    |
  +=======+=============+==+===+===+===+===+=============+
  | TBD2  | Node BPs    |n | y | y | y | y |This document|
  +-------+-------------+--+---+---+---+---+-------------+

IANA is requested to create a new sub-registry "Sub-Sub-TLVs for Node BPs Sub-TLV" as follows:
  +==============+===================+=====================+
  |     Type     |      Name         |    reference        |
  +==============+===================+=====================+
  |     0        |                Reserved                 |
  +--------------+-------------------+---------------------+
  |     1        |   Routed BP       |    This document    |
  +--------------+-------------------+---------------------+
  |     2        |   Localdecap BP   |    This document    |
  +--------------+-------------------+---------------------+
  |     3 - 255  |                Unassigned               |
  +--------------+-------------------+---------------------+

Normative References

Informative References
[RFC2119]
[RFC8174]
[RFC9262]
[RFC8401]
[RFC5305]
[RFC5120]
[I-D.chen-bier-te-lan]
[RFC5308]
Acknowledgments
The authors would like to thank Acee Lindem, Les Ginsberg, Tony Przygienda, Jeffrey Zhang and Toerless Eckert for their comments on this work.